ghc-9.6.3: The GHC API

Safe Haskell | Safe-Inferred
Language | Haskell2010

GHC.Core.Opt.ConstantFold

Description

Constant Folder

Synopsis

- primOpRules :: Name -> PrimOp -> Maybe CoreRule
- builtinRules :: [CoreRule]
- caseRules :: Platform -> CoreExpr -> Maybe (CoreExpr, AltCon -> Maybe AltCon, Id -> CoreExpr)

# Documentation

primOpRules :: Name -> PrimOp -> Maybe CoreRule Source #

builtinRules :: [CoreRule] Source #

caseRules :: Platform -> CoreExpr -> Maybe (CoreExpr, AltCon -> Maybe AltCon, Id -> CoreExpr) Source #

Match the scrutinee of a case and potentially return a new scrutinee and a function to apply to each literal alternative.